unit URPDigitos;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, UApoyo, StdCtrls, math;

type
  TFormRPDig = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ImageR: TImage;
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    ImageHx: TImage;
    ImageHy: TImage;
    Memo1: TMemo;
    Button2: TButton;
    Label1: TLabel;
    Memo2: TMemo;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    BMR    : TBitMap;
    Hx,Hy  : array of integer;
    nx,ny  : integer;

    Umb    : integer;
    ACCx   : array of array[0..1] of integer;
    NCaj   : integer;
    ban    : boolean;

  public
    { Public declarations }
    MRP  : Mat3D;
  end;

var
  FormRPDig: TFormRPDig;

implementation

{$R *.dfm}

procedure TFormRPDig.FormCreate(Sender: TObject);
begin
  BMR := TBitMap.Create;
end;

procedure TFormRPDig.FormShow(Sender: TObject);
begin
  Mat2BM(MRP,BMR);
  ImageR.Picture.Assign(BMR);

  nx := MRP.nc;
  ny := MRP.nr;

  SetLength(Hx,nx);
  SetLength(Hy,ny);
end;

// Histogramas
procedure TFormRPDig.Button1Click(Sender: TObject);
const
  mar = 5;
var
  x,y, kk, mx : integer;
begin
  // sumamos Hx
  for x := 0 to nx - 1 do begin
    Hx[x] := 0;
    for y := 0 to ny - 1 do
      Hx[x] := Hx[x] + ceil(1-MRP.dat[x][y][0]/_lamb);
  end;

  // sumamos Hy
  for y := 0 to ny - 1 do begin
    Hy[y] := 0;
    for x := 0 to nx - 1 do
      Hy[y] := Hy[y] + ceil(1-MRP.dat[x][y][0]/_lamb);
  end;

  // dibujando los histogramas
  mx := Hx[0];
  for kk := 1 to nx - 1 do mx := MAX(mx,Hx[kk]);

  with ImageHx.Canvas do begin
    Rectangle(-1,-1,ImageHx.Width+1, ImageHx.Height+1 );
    Pen.Color := clBlack;
    MoveTo(0,80 - mar - ceil(70*Hx[0]/mx));
    for kk := 1 to nx - 1 do
      LineTo(kk, 80 - mar - ceil(70*Hx[kk]/mx));
    Pen.Color := clBlue;
    MoveTo(0,76); LineTo(nx,76);
  end;

end;

// Pasa a la ceja de cajas y muestra datos
procedure TFormRPDig.Button2Click(Sender: TObject);
var
  kk : integer;
  ss : string;
begin
 PageControl1.TabIndex := 1;

 // Por columnas (X)
 Memo1.Clear;
 for kk := 0 to nx - 1 do begin
   ss := Format('%3d  %5d', [kk,Hx[kk]]);
   Memo1.Lines.Add(ss);
 end;

 Umb := 0;  // sensibilidad de discriminacin
 // cotas de cajas horizontales
 Ncaj := 0;
 ban := true;
 for kk := 0 to nx - 1 do begin

   if (Hx[kk] > Umb) and ban
   then begin
     inc(Ncaj);
     Setlength(ACCx,Ncaj);
     ACCx[Ncaj-1][0] := kk;
     ban := false;
   end;

   if (Hx[kk] <= Umb) and (not ban)
   then begin
     ACCx[Ncaj-1][1] := kk-1;
     ban := true;
   end;

 end;

 Memo2.Lines.Add('NCaj = '+IntToStr(Ncaj));
 Memo2.Lines.Add(' ');
 for kk := 0 to Ncaj - 1 do begin
   ss := Format('%3d  %5d  %5d', [kk+1,ACCx[kk][0],ACCx[kk][1]]);
   Memo2.Lines.Add(ss);
 end;


end;






end.
